Attribute VB_Name = "Module1"
Option Explicit

Private Declare Function CreateFile Lib "kernel32.dll" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function SetFilePointer Lib "kernel32.dll" (ByVal hFile As Long, ByVal lDistanceToMove As Long, lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Any) As Long
Private Declare Function CloseHandle Lib "kernel32.dll" (ByVal hObject As Long) As Long
Private Declare Function OpenFile Lib "kernel32" (ByVal lpFileName As String, lpReOpenBuff As OFSTRUCT, ByVal wStyle As Long) As Long

Type OFSTRUCT
    cBytes As Byte
    fFixedDisk As Byte
    nErrCode As Integer
    Reserved1 As Integer
    Reserved2 As Integer
    szPathName(255) As Byte
End Type

Const GENERAL_READ = &H80000000
Const GENERAL_WRITE = &H40000000
Const FILE_SHARE_READ = &H1
Const FILE_SHARE_WRITE = &H2
Const CREATE_ALWAYS = 2
Const CREATE_NEW = 1
Const OPEN_ALWAYS = 4
Const OPEN_EXISTING = 3
Const TRUNCATE_EXISTING = 5
Const FILE_ATTRIBUTE_ARCHIVE = &H20
Const FILE_ATTRIBUTE_HIDDEN = &H2
Const FILE_ATTRIBUTE_NORMAL = &H80
Const FILE_ATTRIBUTE_READONLY = &H1
Const FILE_ATTRIBUTE_SYSTEM = &H4
Const FILE_FLAG_DELETE_ON_CLOSE = &H4000000
Const FILE_FLAG_NO_BUFFERING = &H20000000
Const FILE_FLAG_OVERLAPPED = &H40000000
Const FILE_FLAG_POSIX_SEMANTICS = &H1000000
Const FILE_FLAG_RANDOM_ACCESS = &H10000000
Const FILE_FLAG_SEQUENTIAL_SCAN = &H8000000
Const FILE_FLAG_WRITE_THROUGH = &H80000000
Const FILE_BEGIN = 0
Const FILE_CURRENT = 1
Const FILE_END = 2


Public Function GetFileLength(FileName As String) As Currency
Dim lowbyte As Long, highbyte As Long, midbyte As Long, mid2byte As Long   ' components of file pointer position
Dim hFile As Long  ' handle of the open file
Dim retval As Long  ' return value

hFile = CreateFile(FileName, GENERAL_READ, FILE_SHARE_READ, ByVal CLng(0), OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, 0)
If hFile = -1 Then  ' the file could not be opened
  Debug.Print "Unable to open the file:" & FileName & " for length-- it probably does not exist."
  GetFileLength = 0
  Exit Function  ' abort the program
End If
highbyte = 0
lowbyte = SetFilePointer(hFile, lowbyte, highbyte, FILE_END)  ' move the file pointer there
midbyte = 0
mid2byte = 0
' MsgBox ("Size:" & lowbyte & " " & highbyte)
If lowbyte < 0 Then
   lowbyte = 2147483647 + lowbyte
   midbyte = 2147483647
   mid2byte = 2
End If
GetFileLength = (2 ^ 32) * highbyte + lowbyte + midbyte + mid2byte
retval = CloseHandle(hFile)
End Function


Public Sub GetFileString(FileName As String, strLen As Long, offset As Long, reverse As Boolean, myLongStr As String)
Dim lowbyte As Long, highbyte As Long, midbyte As Long, mid2byte As Long   ' components of file pointer position
Dim hFile As Long  ' handle of the open file
Dim numread As Long ' receives number of bytes read from file
Dim retval As Long  ' return value

hFile = CreateFile(FileName, GENERAL_READ, FILE_SHARE_READ, ByVal CLng(0), OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, 0)
If hFile = -1 Then  ' the file could not be opened
  Debug.Print "Unable to open the file for read-- it probably does not exist."
  myLongStr = ""
  Exit Sub       ' abort the program
End If

If reverse Then
   lowbyte = (Not offset) + 1
   highbyte = Not 0
   lowbyte = SetFilePointer(hFile, lowbyte, highbyte, FILE_END)
Else
   lowbyte = offset
   highbyte = 0
   lowbyte = SetFilePointer(hFile, lowbyte, highbyte, FILE_BEGIN)
End If

retval = ReadFile(hFile, ByVal myLongStr, strLen, numread, ByVal CLng(0))
retval = CloseHandle(hFile)
End Sub

 
Public Function FileExists(FileName As String) As Boolean
    Dim RetCode As Integer
    Dim OpenFileStructure As OFSTRUCT

    Const OF_EXIST = &H4000
    Const FILE_NOT_FOUND = 2

    RetCode = OpenFile(FileName$, OpenFileStructure, OF_EXIST)
    If RetCode < 0 Then
    'If OpenFileStructure.nErrCode = FILE_NOT_FOUND Then
        FileExists = False
    Else
        FileExists = True
    End If
End Function

