Attribute VB_Name = "Module2"
Option Explicit
Private Declare Function GetStdHandle Lib "kernel32" (ByVal nStdHandle As Long) As Long
Private Declare Function WriteFile Lib "kernel32" _
       (ByVal hFile As Long, _
        ByVal lpBuffer As String, _
        ByVal cToWrite As Long, _
        ByRef cWritten As Long, _
        Optional ByVal lpOverlapped As Long) As Long
Dim SupFile As String
Dim PalFile As String
Dim ErrStr As String
Dim gdip As cGDIP
Dim bitmap As cBitmap
'Dim scrGraphics As cGraphics
Dim OrigPaletteValues(0 To 15) As Long
Dim OrigRGBValues(0 To 15) As Long
Dim TestYCrCbValues(0 To 15) As Long
Dim SubPaletteStr As String
Dim PalColors(0 To 3) As Long
Dim PalARGBColors(0 To 3) As Long



'  Use VB linker:
'  link /edit /subsystem:console sub2png.exe

Public Sub Main()
Dim s As String
Dim s1 As String
Dim s2 As String
Dim i As Integer
Dim j As Integer
Dim k As Integer
Dim pngpath As String
Dim cmdLine As String
Dim ErrStr As String
Dim NewBack As Long

cmdLine = Command()
If ((cmdLine = "-h") Or (cmdLine = "?") Or (cmdLine = "") Or (InStr(1, cmdLine, Chr(34), vbTextCompare) = 0)) Then
    ErrStr = "sup2png is a VB port of pxsup2dast using GDI+" & vbCrLf
    WriteError ErrStr
    ErrStr = "See: http://www.guru-group.fi/~too/sw/m2vmp2cut/pxsup2dast.c" & vbCrLf
    WriteError ErrStr
    ErrStr = vbCrLf
    WriteError ErrStr
    ErrStr = "Usage: sup2png " & Chr(34) & "subfile.sup" & Chr(34) & " " & Chr(34) & "palette.ifo/pal/rgb" & Chr(34) & vbCrLf
    WriteError ErrStr
    ErrStr = "The palette.ifo/pal/rgb file is optional but recommended." & vbCrLf
    WriteError ErrStr
    ErrStr = "Otherwise only the spumux default palette is used." & vbCrLf
    WriteError ErrStr
    ErrStr = "The path (of both sup and ifo/pal/rgb file) has to be" & vbCrLf
    WriteError ErrStr
    ErrStr = "enclosed with quotes (" & Chr(34) & ")" & vbCrLf
    WriteError ErrStr
    ErrStr = vbCrLf
    WriteError ErrStr
    ErrStr = "Example: sup2png " & Chr(34) & "c:\subs\subtitles.sup" & Chr(34) & " " & Chr(34) & "c:\subs\subtitles.ifo" & Chr(34) & vbCrLf
    WriteError ErrStr
    End
End If

If Len(Command()) < 3 Then End

'Get sup filename
i = InStr(1, cmdLine, Chr(34), vbTextCompare)
j = InStr(i + 1, cmdLine, Chr(34), vbTextCompare)
If j = 0 Then
    ErrStr = "ERR: Wrong commandline syntax!" & vbCrLf
    WriteError ErrStr
    End
  Else
    SupFile = Mid$(cmdLine, i + 1, j - i - 1)
    If Not FileExists(SupFile) Then
        ErrStr = "ERR: SUP-File " & SupFile & " not found!" & vbCrLf
        WriteError ErrStr
        End
    End If
End If
           
           
PalFile = ""
SubPaletteStr = ""
If (j + 3) < Len(cmdLine) Then
'Get palette filename
i = InStr(j + 1, cmdLine, Chr(34), vbTextCompare)
j = InStr(i + 1, cmdLine, Chr(34), vbTextCompare)
    If j = 0 Then
        ErrStr = "ERR: Wrong commandline syntax!" & vbCrLf
        WriteError ErrStr
        End
      Else
        PalFile = Mid$(cmdLine, i + 1, j - i - 1)
        If Not FileExists(PalFile) Then
            ErrStr = "ERR: SUP-File: " & PalFile & " not found!" & vbCrLf
            WriteError ErrStr
            End
          Else
            ReadPalette (PalFile)
        End If
    End If
End If

ConvertPalette
CreatePngFiles

End Sub


Private Sub WriteError(ErrStr As String)
Dim hStdOut As Long, BytesWritten As Long

hStdOut = GetStdHandle(-11&)
Call WriteFile(hStdOut, ByVal ErrStr, Len(ErrStr), BytesWritten, 0&)

End Sub

Private Sub ReadPalette(PalFile As String)
Dim i As Integer
Dim j As Integer
Dim iFile As Integer
Dim FileStr As String
Dim s As String
Dim s0 As String
Dim s1 As String
Dim s2 As String
Dim FL As Currency
Dim L1 As Long
Dim L2 As Long
Dim L3 As Long
Dim L4 As Long
Dim b1 As Byte
Dim b2 As Byte
Dim b3 As Byte
Dim b4 As Byte

SubPaletteStr = ""

s2 = PalFile
   i = InStrRev(s2, ".", , vbTextCompare)
   If i = 0 Then
        ErrStr = "ERR: Illegal Palette-File: " & PalFile & " !" & vbCrLf
        WriteError ErrStr
        End
   End If
   s0 = LCase(Mid$(s2, i, 4))
   Select Case s0
       '########  IFO  ##################################
       Case ".ifo"
         FL = GetFileLength(s2)
         If FL > 1048576 Then
            MsgBox "Illegal file"
            Exit Sub
         End If
         L1 = CLng(FL)
         FileStr = String$(L1, 0)
         GetFileString s2, L1, 0, False, FileStr
         s = Mid$(FileStr, 1, 12)
         If s <> "DVDVIDEO-VTS" Then
            ErrStr = "ERR: Illegal Palette-File: " & PalFile & " !" & vbCrLf
            WriteError ErrStr
            End
         End If
         b2 = Asc(Mid$(FileStr, &HCE, 1))
         b3 = Asc(Mid$(FileStr, &HCF, 1))
         b4 = Asc(Mid$(FileStr, &HD0, 1))
         L2 = (CLng(b4) + CLng(b3) * 256& + CLng(b2) * 65536) * &H800
         b2 = Asc(Mid$(FileStr, L2 + 14, 1))
         b3 = Asc(Mid$(FileStr, L2 + 15, 1))
         b4 = Asc(Mid$(FileStr, L2 + 16, 1))
         L3 = (CLng(b4) + CLng(b3) * 256& + CLng(b2) * 65536)
         L4 = L2 + L3 + &HA4
         s = ""
         For i = 0 To 15
            L2 = (L4 + (i * 4))
            b2 = Asc(Mid$(FileStr, L2 + 2, 1))
            b3 = Asc(Mid$(FileStr, L2 + 3, 1))
            b4 = Asc(Mid$(FileStr, L2 + 4, 1))
         L3 = (CLng(b2) + CLng(b3) * 256& + CLng(b4) * 65536)
         s = s & L3 & ","
         Next
         SubPaletteStr = Mid$(s, 1, Len(s) - 1)
       Case ".pal"
       ' dvdauthor palette file in YCrCb
         iFile = FreeFile
         i = 0
         s = ""
         Open s2 For Input As #iFile
         Do While Not EOF(iFile)
            Line Input #iFile, s1
            If ((Len(s1) >= 112) And (InStr(1, s1, vbLf, vbTextCompare))) Then
               'Probably UNIX
               For j = 0 To 15
                    b2 = Val("&h" & Mid$(s1, (i + (j * 6) + 1), 2))
                    b3 = Val("&h" & Mid$(s1, (i + (j * 6) + 3), 2))
                    b4 = Val("&h" & Mid$(s1, (i + (j * 6) + 5), 2))
                    L3 = (CLng(b2) + CLng(b3) * 256& + CLng(b4) * 65536)
                    s = s & L3 & ","
                    i = i + 1
               Next j
              Else
                If Len(s1) > 5 Then
                    b2 = Val("&h" & Mid$(s1, 1, 2))
                    b3 = Val("&h" & Mid$(s1, 3, 2))
                    b4 = Val("&h" & Mid$(s1, 5, 2))
                    L3 = (CLng(b2) + CLng(b3) * 256& + CLng(b4) * 65536)
                    s = s & L3 & ","
                    i = i + 1
                End If
            End If
            If i > 16 Then Exit Do
         Loop
         Close #iFile
         If i <> 16 Then
            ErrStr = "ERR: Illegal Palette-File: " & PalFile & " !" & vbCrLf
            WriteError ErrStr
            End
         End If
         SubPaletteStr = Mid$(s, 1, Len(s) - 1)
       Case ".rgb"
       ' dvdauthor palette file in RGB
         iFile = FreeFile
         i = 0
         s = ""
         Open s2 For Input As #iFile
         Do While Not EOF(iFile)
            Line Input #iFile, s1
            If ((Len(s1) >= 112) And (InStr(1, s1, vbLf, vbTextCompare))) Then
               'Probably UNIX
               For j = 0 To 15
                    b2 = Val("&h" & Mid$(s1, (i + (j * 6) + 1), 2))
                    b3 = Val("&h" & Mid$(s1, (i + (j * 6) + 3), 2))
                    b4 = Val("&h" & Mid$(s1, (i + (j * 6) + 5), 2))
                    L3 = RGB2YCrCb(b2, b3, b4)
                    s = s & L3 & ","
                    i = i + 1
               Next j
              Else
                If Len(s1) > 5 Then
                    b2 = Val("&h" & Mid$(s1, 1, 2))
                    b3 = Val("&h" & Mid$(s1, 3, 2))
                    b4 = Val("&h" & Mid$(s1, 5, 2))
                    L3 = RGB2YCrCb(b2, b3, b4)
                    s = s & L3 & ","
                    i = i + 1
                End If
            End If
            If i > 16 Then Exit Do
         Loop
         Close #iFile
         If i <> 16 Then
            ErrStr = "ERR: Illegal Palette-File: " & PalFile & " !" & vbCrLf
            WriteError ErrStr
            End
         End If
         SubPaletteStr = Mid$(s, 1, Len(s) - 1)
        Case Else
            ErrStr = "ERR: Illegal Palette-File: " & PalFile & " !" & vbCrLf
            WriteError ErrStr
            End
        End Select
End Sub


Private Function RGB2YCrCb(r As Byte, g As Byte, b As Byte) As Long
Dim Y As Long, Cr As Long, Cb As Long

Y = Int((257& * r + 504& * g + 98& * b + 16500&) / 1000)
Cr = Int((439& * r - 368& * g - 71& * b + 128500) / 1000)
Cb = Int((-148& * r - 291& * g + 439& * b + 128500) / 1000)
RGB2YCrCb = (Y + Cr * 256& + Cb * 65536)
End Function

Private Sub ConvertPalette()
Dim i As Integer
Dim j As Integer
Dim s As String
Dim s1 As String

s = SubPaletteStr
If s <> "" Then
    j = InStr(1, s, ",", vbTextCompare) - 1 '
    OrigPaletteValues(0) = Val(Mid$(s, 1, j))
    OrigRGBValues(0) = LYCrCb2RGB(OrigPaletteValues(0))
    TestYCrCbValues(0) = LRGB2YCrCb(OrigRGBValues(0))
    s1 = s
    For i = 1 To 14
        s1 = Mid$(s1, j + 2)
        j = InStr(1, s1, ",", vbTextCompare) - 1 '
        OrigPaletteValues(i) = Val(Mid$(s1, 1, j))
        OrigRGBValues(i) = LYCrCb2RGB(OrigPaletteValues(i))
        TestYCrCbValues(i) = LRGB2YCrCb(OrigRGBValues(i))
    Next
    s1 = Mid$(s1, j + 2)
    OrigPaletteValues(15) = Val(Mid$(s1, 1))
    OrigRGBValues(15) = LYCrCb2RGB(OrigPaletteValues(15))
    TestYCrCbValues(15) = LRGB2YCrCb(OrigRGBValues(15))
 Else
    OrigPaletteValues(0) = 8421392
    OrigPaletteValues(1) = 8421393
    OrigPaletteValues(2) = 8421611
    OrigPaletteValues(3) = 8421392
    OrigPaletteValues(4) = 8421392
    OrigPaletteValues(5) = 8421392
    OrigPaletteValues(6) = 8421392
    OrigPaletteValues(7) = 8421392
    OrigPaletteValues(8) = 8421392
    OrigPaletteValues(9) = 8421392
    OrigPaletteValues(10) = 8421392
    OrigPaletteValues(11) = 8421392
    OrigPaletteValues(12) = 8421392
    OrigPaletteValues(13) = 8421392
    OrigPaletteValues(14) = 8421392
    OrigPaletteValues(15) = 8421392
    For i = 0 To 15
        OrigRGBValues(i) = LYCrCb2RGB(OrigPaletteValues(i))
        TestYCrCbValues(i) = LRGB2YCrCb(OrigRGBValues(i))
    Next

End If

'Check:
For i = 0 To 15
  If OrigPaletteValues(i) <> 0 Then
    If OrigPaletteValues(i) <> TestYCrCbValues(i) Then
            ErrStr = "Warning: Color " & i & " is not lossless convertible" & vbCrLf
            WriteError ErrStr
            ErrStr = "OrigPaletteYCrCbValue=" & Hex2(OrigPaletteValues(i)) & "; RGB->YCrCbValue:" & Hex2(TestYCrCbValues(i)) & vbCrLf
            WriteError ErrStr
    End If
  End If
Next

End Sub

Private Function Hex2(LYCrCb As Long) As String
Dim s As String
Dim s1 As String
Dim Y As Long, Cr As Long, Cb As Long

Y = LYCrCb And 255&
Cr = (LYCrCb \ 256&) And 255&
Cb = (LYCrCb \ 65536) And 255&
s1 = Hex(Y)
If Len(s1) < 2 Then s1 = "0" & s1
s = Hex(Cr)
If Len(s) < 2 Then s = "0" & s
s1 = s1 & s
s = Hex(Cb)
If Len(s) < 2 Then s = "0" & s
Hex2 = s1 & s

End Function


Private Function YCrCb2RGB(Y As Byte, Cr As Byte, Cb As Byte) As Long
Dim lR As Long, lG As Long, lB As Long

If ((Y = 0) And (Cr = 0) And (Cb = 0)) Then
   YCrCb2RGB = 0
   Exit Function
End If

    lR = Int(((500& + 1164& * (Y - 16) + 1596& * (Cr - 128)) / 1000))
    lG = Int(((500& + 1164& * (Y - 16) - 813& * (Cr - 128) - 391& * (Cb - 128)) / 1000))
    lB = Int(((500& + 1164& * (Y - 16) + 2018& * (Cb - 128)) / 1000))
If lR < 0 Then lR = 0
If lR > 255 Then lR = 255
If lG < 0 Then lG = 0
If lG > 255 Then lG = 255
If lB < 0 Then lB = 0
If lB > 255 Then lB = 255
YCrCb2RGB = RGB(lR, lG, lB)
End Function


Private Function LYCrCb2RGB(LYCrCb As Long) As Long
Dim lR As Long, lG As Long, lB As Long
Dim Y As Long, Cr As Long, Cb As Long

Y = LYCrCb And 255&
Cr = (LYCrCb \ 256&) And 255&
Cb = (LYCrCb \ 65536) And 255&

If ((Y = 0) And (Cr = 0) And (Cb = 0)) Then
   LYCrCb2RGB = 0
   Exit Function
End If

lR = Int((500& + 1164& * (Y - 16) + 1596& * (Cr - 128)) / 1000)
lG = Int((500& + 1164& * (Y - 16) - 813& * (Cr - 128) - 391& * (Cb - 128)) / 1000)
lB = Int((500& + 1164& * (Y - 16) + 2018& * (Cb - 128)) / 1000)

If lR < 0 Then lR = 0
If lR > 255 Then lR = 255
If lG < 0 Then lG = 0
If lG > 255 Then lG = 255
If lB < 0 Then lB = 0
If lB > 255 Then lB = 255
LYCrCb2RGB = RGB(lR, lG, lB)
End Function

Private Function LRGB2YCrCb(LRGB As Long) As Long
Dim Y As Long, Cr As Long, Cb As Long
Dim r As Long, g As Long, b As Long

r = LRGB And 255&
g = (LRGB \ 256&) And 255&
b = (LRGB \ 65536) And 255&

Y = Int((257& * r + 504& * g + 98& * b + 16500&) / 1000)
Cr = Int((439& * r - 368& * g - 71& * b + 128500) / 1000)
Cb = Int((-148& * r - 291& * g + 439& * b + 128500) / 1000)
LRGB2YCrCb = (Y + Cr * 256& + Cb * 65536)
End Function


Function GetARGBColor(LRGB As Long, trans As Byte) As Long
Dim i As Long
Dim s As String
Dim s0 As String
Dim s1 As String
Dim r As Long, g As Long, b As Long

r = LRGB And 255&
g = (LRGB \ 256&) And 255&
b = (LRGB \ 65536) And 255&

s1 = "&H"
s = Hex(trans * 16)
If Len(s) = 1 Then s = "0" & s
s1 = s1 & s
s = Hex(r)
If Len(s) = 1 Then s = "0" & s
s1 = s1 & s
s = Hex(g)
If Len(s) = 1 Then s = "0" & s
s1 = s1 & s
s = Hex(b)
If Len(s) = 1 Then s = "0" & s
s1 = s1 & s & "&"

GetARGBColor = Val(s1)
         ' A R G B
'Color = &H6FFF0000

End Function


Private Sub CreatePngFiles()
Dim fPointer As Long
Dim fSize As Long
Dim test As Boolean
Dim i As Long
Dim j As Long
Dim pts As Currency
Dim SP As Integer
Dim b1 As Byte
Dim b2 As Byte
Dim b3 As Byte
Dim b4 As Byte
Dim s1 As String
Dim s2 As String
Dim subsize As Long
Dim ctrlsize As Long
Dim data() As Byte

fPointer = 0
fSize = FileLen(SupFile)
i = 0
Set gdip = New cGDIP       ' Initialize GDI+

Open SupFile For Binary As #1
  While Not (EOF(1) Or (fPointer > (fSize - 14)))
     Get #1, , SP
     If SP <> 20563 Then
        Close #1
        Set gdip = Nothing
        ErrStr = "ERR:  No SUP signature found" & vbCrLf
        WriteError ErrStr
        End
     End If
     Get #1, , pts
     Get #1, , b1
     Get #1, , b2
     Get #1, , b3
     Get #1, , b4
     subsize = (b1 * 256) + b2
     ctrlsize = (b3 * 256) + b4
     ReDim data(subsize - 5)
     Get #1, , data
     fPointer = fPointer + 10 + subsize
     If i = 0 Then
     'Reset _spu.xml file if any
        s1 = Mid$(SupFile, 1, Len(SupFile) - 4) & ".d"
        On Error Resume Next
        MkDir s1
        If Err.number <> 0 Then Err.Clear
        s2 = s1 & "\spumux.xml"
        On Error Resume Next
        Open s2 For Output As #2
        If Err.number <> 0 Then
           Err.Clear
           Close #1
           Set gdip = Nothing
           ErrStr = "ERR: Cannot open Spufile " & s2 & " !" & vbCrLf
           WriteError ErrStr
           End
          Else
           Print #2, "<subpictures>"
           Print #2, "  <stream>"
           Close #2
        End If
     End If
     test = GetSubTitle(data, subsize, ctrlsize, pts, SupFile)
     i = i + 1
     If Not (test) Then
        ErrStr = "ERR:  Conversion of subtitle " & i & " failed" & vbCrLf
        WriteError ErrStr
        fPointer = fSize
     End If
  Wend
Close #1

'close _spu.xml file if any
   s2 = Mid$(SupFile, 1, Len(SupFile) - 4) & ".d\spumux.xml"
   On Error Resume Next
   Open s2 For Append As #2
   If Err.number <> 0 Then
      Err.Clear
      On Error Resume Next
      Close #2
      ErrStr = "ERR: Cannot open Spufile " & s2 & " !" & vbCrLf
      WriteError ErrStr
     Else
      Print #2, "  </stream>"
      Print #2, "</subpictures>"
      Close #2
   End If
Set gdip = Nothing

ErrStr = "INFO: " & i & " png files created" & vbCrLf
WriteError ErrStr

End Sub

Private Function GetSubTitle(data() As Byte, subsize As Long, ctrlsize As Long, pts As Currency, fname As String) As Boolean
Dim i As Long
Dim j As Long
Dim test As Boolean
Dim h As Long
Dim m As Long
Dim s As Long
Dim hs As Long
Dim pts1 As Currency
Dim h2 As Long
Dim m2 As Long
Dim ss2 As Long
Dim hs2 As Long
Dim pts2 As Currency
Dim b1 As Byte
Dim b2 As Byte
Dim b3 As Byte
Dim b4 As Byte
Dim s1 As String
Dim s2 As String
Dim s3 As String
Dim s4 As String
Dim sprior As Long
Dim sdate As Long
Dim snext As Long
Dim x1 As Integer
Dim x2 As Integer
Dim y1 As Integer
Dim y2 As Integer
Dim color(1 To 4) As Byte
Dim trans(1 To 4) As Byte

Dim Offset_even As Long
Dim Offset_odd As Long


    pts1 = pts * 10000

    h = Int(pts1 / (3600& * 90000))
    m = Int(pts1 / (60& * 90000)) Mod 60
    s = Int(pts1 / 90000) Mod 60
    hs = Int((pts1 + 450&) / 900&) Mod 100

sprior = ctrlsize
sdate = 0
snext = 0
x1 = -1
x2 = -1
y1 = -1
y2 = -1
Offset_even = -1
Offset_odd = -1
For i = 1 To 4
color(i) = 100
trans(i) = 100
Next

i = ctrlsize - 4

j = 0
Do Until ((i >= (UBound(data) - 4)) Or (sprior = snext))
    j = j + 1
    'Debug.Print "-------------------------------------------------"
    'Debug.Print "Seq " & j & ":"

    sdate = data(i) * 256 + data(i + 1)
    i = i + 2
    If snext = 0 Then sprior = ctrlsize Else sprior = snext
    snext = data(i) * 256 + data(i + 1)
    i = i + 2
    While ((b1 <> &HFF) And (i < UBound(data)))
    b1 = data(i)
    Select Case b1
           Case 0
                'force display => do nothing
                i = i + 1
           Case 1
                'start date => do nothing
                i = i + 1
           Case 2
                'stop date => do nothing
                i = i + 1
           Case 3
                'colors
                i = i + 1
                color(4) = Int((data(i) And &HF0) / 16)
                color(3) = Int((data(i) And &HF))
                i = i + 1
                color(2) = Int((data(i) And &HF0) / 16)
                color(1) = Int((data(i) And &HF))
                'Debug.Print "Colors: " & color(1) & "," & color(2) & "," & color(3) & "," & color(4)
                i = i + 1
           Case 4
                'transinfo
                i = i + 1
                trans(4) = Int((data(i) And &HF0) / 16)
                trans(3) = Int((data(i) And &HF))
                i = i + 1
                trans(2) = Int((data(i) And &HF0) / 16)
                trans(1) = Int((data(i) And &HF))
                'Debug.Print "Transp: " & trans(1) & "," & trans(2) & "," & trans(3) & "," & trans(4)
                i = i + 1
           Case 5
                'coordinates
                i = i + 1
                b2 = data(i)
                i = i + 1
                b3 = data(i)
                x1 = 16 * b2 + Int((b3 And &HF0) / 16)
                i = i + 1
                b2 = data(i)
                x2 = Int((b3 And &HF)) * 256 + b2
                i = i + 1
                b2 = data(i)
                i = i + 1
                b3 = data(i)
                y1 = 16 * b2 + Int((b3 And &HF0) / 16)
                i = i + 1
                b2 = data(i)
                y2 = Int((b3 And &HF)) * 256 + b2
                'Debug.Print "Position (x1,x2,y1,y2): " & x1 & "," & x2 & "," & y1 & "," & y2
                i = i + 1
           Case 6
                'offsets
                i = i + 1
                Offset_even = CLng(data(i) * 256&) + CLng(data(i + 1))
                i = i + 2
                Offset_odd = CLng(data(i) * 256&) + CLng(data(i + 1))
                i = i + 2
                'Debug.Print "Offset_even : " & Offset_even & "  ,Offset_odd: " & Offset_odd
           Case Else
                i = i + 1
          End Select
    Wend
    
    'Debug.Print "date: " & sdate
        
    'Debug.Print vbCrLf
    'Debug.Print "ctrlsize: " & Hex(ctrlsize)
    'Debug.Print "sprior: " & Hex(sprior)
    'Debug.Print "snext: " & Hex(snext)
    'Debug.Print vbCrLf
    
    'Debug.Print "Offset: " & Hex(i) & "   of (" & Hex(subsize - 5) & ")"
Loop


'Debug.Print "timecode= " & format(h, "00") & ":" & format(m, "00") & ":" & format(s, "00") & ":" & format(hs, "00")

test = True
For i = 1 To 4
    If color(i) > 16 Then test = False
    If trans(i) > 16 Then test = False
Next
If x1 < 0 Then test = False
If x2 < 0 Then test = False
If y1 < 0 Then test = False
If y2 < 0 Then test = False
If Offset_even < 0 Then test = False
If Offset_odd < 0 Then test = False
If snext = 0 Then test = False

If sdate <> 0 Then
    pts2 = pts1 + (sdate * 1000)

    h2 = Int(pts2 / (3600& * 90000))
    m2 = Int(pts2 / (60& * 90000)) Mod 60
    ss2 = Int(pts2 / 90000) Mod 60
    hs2 = Int((pts2 + 450&) / 900&) Mod 100
 Else
 'No End flag;
End If

If test Then
'get colors
    For i = 1 To 4
        PalColors(i - 1) = OrigRGBValues(color(i))
        PalARGBColors(i - 1) = GetARGBColor(PalColors(i - 1), trans(i))
    Next
    'set up filenames
    s2 = Mid$(fname, 1, Len(fname) - 4) & ".d"
    s3 = Mid$(fname, 1, Len(fname) - 4) & ".d\spumux.xml"
    On Error Resume Next
    Open s3 For Append As #2
    If Err.number <> 0 Then
       Err.Clear
       ErrStr = "ERR: Cannot open Spufile " & s3 & " !" & vbCrLf
       WriteError ErrStr
      Else
       s4 = "    <spu start=" & Chr(34) & Format(h, "00") & ":" & Format(m, "00") & ":" & Format(s, "00") & "." & Format(hs, "00") & Chr(34) & " "
       If sdate <> 0 Then s4 = s4 & "end=" & Chr(34) & Format(h2, "00") & ":" & Format(m2, "00") & ":" & Format(ss2, "00") & "." & Format(hs2, "00") & Chr(34) & " "
       s4 = s4 & "image=" & Chr(34) & s2 & "\" & Format(h, "00") & "+" & Format(m, "00") & "+" & Format(s, "00") & "." & Format(hs, "00") & ".png" & Chr(34) & " "
       s4 = s4 & "xoffset=" & Chr(34) & x1 & Chr(34) & " "
       s4 = s4 & "yoffset=" & Chr(34) & y1 & Chr(34) & " />"
       Print #2, s4
       Close #2
    End If
   On Error Resume Next
   MkDir s2
   If Err.number <> 0 Then Err.Clear
   s2 = s2 & "\" & Format(h, "00") & "+" & Format(m, "00") & "+" & Format(s, "00") & "." & Format(hs, "00") & ".png"
   MakeARGBBitmap data, x1, x2, y1, y2, Offset_even, Offset_odd, s2
End If

GetSubTitle = test
End Function

Private Function GetNibble(data() As Byte, actnibble As Integer, datapointer As Long) As Byte
    If actnibble >= 0 Then
       GetNibble = actnibble And &HF
       'Debug.Print "+Nibble: " & (actnibble And &HF)
       actnibble = -1
     Else
      datapointer = datapointer + 1
      If datapointer < UBound(data) Then
         actnibble = data(datapointer)
         GetNibble = Int(actnibble / 16)
         'Debug.Print "-Nibble: " & Int(actnibble / 16)
        Else
         actnibble = data(datapointer - 1)
         GetNibble = Int(actnibble / 16)
         'Debug.Print "--Nibble: " & Int(actnibble / 16)
      End If
    End If
    
End Function


Private Function GetSubLine2(data() As Byte, BData() As Long, linepointer As Long, actline As Long, subwidth As Long) As Boolean
Dim datapointer As Long
Dim bits As Long
Dim actnibble As Integer
Dim col As Integer
Dim number As Long
Dim cindex As Long
Dim tindex As Integer
Dim testcolor As Long
Dim X As Long
Dim x1 As Long
Dim x2 As Long
Dim i As Integer


actnibble = -1
datapointer = linepointer
tindex = 0
col = 0
number = 0

Do Until ((number = subwidth) Or (col >= subwidth))
 bits = GetNibble(data, actnibble, datapointer)
 If (bits And &HC&) <> 0 Then
    ' have 4-bit code
    number = Int((bits And &HC&) / 4)
    cindex = bits And &H3&
   Else
    bits = ((bits * 16) Or GetNibble(data, actnibble, datapointer))
      If ((bits And &HF0&) <> 0) Then
          ' have 8-bit code
          number = Int((bits And &H3C) / 4)
          cindex = bits And &H3&
         Else
          bits = ((bits * 16) Or GetNibble(data, actnibble, datapointer))
            If ((bits And &HFC0&) <> 0) Then
               ' have 12-bit code
               number = Int((bits And &HFC&) / 4)
               cindex = bits And &H3&
              Else
                 ' must have 16-bit code
                 bits = ((bits * 16) Or GetNibble(data, actnibble, datapointer))
                 number = Int((bits And &H3FC&) / 4)
                 cindex = bits And &H3&
                 If (number = 0) Then
                    number = subwidth
                    'carriage return code
                 End If
            End If
      End If
 End If
 testcolor = PalARGBColors(cindex)
  
 x1 = subwidth * actline - 1
    For i = 1 To number
      If (col + i) <= (subwidth) Then
         BData(x1 + col + i) = testcolor
        Else
         Exit For
      End If
    Next
    col = col + number
Loop

linepointer = datapointer
GetSubLine2 = True
End Function


Private Function MakeARGBBitmap(data() As Byte, x1 As Integer, x2 As Integer, y1 As Integer, y2 As Integer, evenoffs As Long, oddoffs As Long, pngname As String) As Boolean
Dim i As Long
Dim j As Long
Dim Y As Long
Dim X As Long
Dim EvenLinePointer As Long
Dim OddLinePointer As Long
Dim FinalEvenLinePointer As Long
Dim FinalOddLinePointer As Long
Dim s1 As String
Dim BData() As Long
Dim bd As BitmapData
Dim rc As RECT
Dim lIndex As Long
Dim tguid As CLSID
Dim lWidth As Long
Dim lHeight As Long

lWidth = CLng(x2 - x1) + 1
lHeight = CLng(y2 - y1) + 1

  Set bitmap = New cBitmap
  Set bitmap.gdip = gdip     ' Reference for error handling. Completely optional.
  
  bitmap.CreateFromScan0 lWidth, lHeight, 0, PixelFormat32bppARGB, 0
  ReDim BData((lWidth * lHeight) - 1)

    bd.Height = lHeight
    bd.Width = lWidth
    bd.PixelFormat = PixelFormat32bppARGB
    
    Y = ((lWidth * lHeight) - 1)
    bd.Scan0 = VarPtr(BData(0))
    bd.Stride = CLng(lWidth * 4)

    rc.Bottom = lHeight
    rc.Right = lWidth
    X = bitmap.LockBits(rc, ImageLockModeWrite Or ImageLockModeUserInputBuf, PixelFormat32bppARGB, bd)
    
        EvenLinePointer = evenoffs - 5
        OddLinePointer = oddoffs - 5
        FinalEvenLinePointer = OddLinePointer
        FinalOddLinePointer = UBound(data)
        For i = 0 To lHeight - 2 Step 2
            'Debug.Print "Line: " & i & "evenlinepointer: " & evenlinepointer
            GetSubLine2 data, BData, EvenLinePointer, i, lWidth
            'Debug.Print "Line: " & i + 1 & "oddlinepointer: " & oddlinepointer
            GetSubLine2 data, BData, OddLinePointer, i + 1, lWidth
            'Exception code:
            If EvenLinePointer > FinalEvenLinePointer Then Exit For
            If OddLinePointer > FinalOddLinePointer Then Exit For
        Next
    
    X = bitmap.UnlockBits(bd)
    lIndex = bitmap.ExtensionExists("*.png")
    If FileExists(pngname) Then
       On Error Resume Next
       Kill pngname
    End If
    bitmap.SaveToFile pngname, bitmap.EncoderGuid(lIndex), 0
    Set bitmap = Nothing

MakeARGBBitmap = True

End Function

